/*
This program is just a rough example of distribution of text via MPI_Scatterv, and is not expected to compile,
let alone run. Hell, it might make your computer explode.
*/


int main(int narg, char *argv) {

    int myrank, numprocs;
    int n, l, n_local, init_disp;
    int *sizes, *disps;
    char *text, *text_local;

    MPI_Init(&narg, argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
    MPI_Comm_size(MPI_COMM_WORLD, &numprocs);

    if (myrank == 0) {
        // Process 0 reads data
        // etc
    }

    // Well everyone seems to need l and n, so...
    MPI_Bcast(&l, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&n, MPI_INT, 0, MPI_COMM_WORLD);

    n_local = n / numprocs;
    if (myrank < n % numprocs) n_local ++;
    if (myrank == 0)
        text = (char *) malloc(n_local * sizeof(char));
    else
        text = (char *) malloc((n_local + l - 1) *  sizeof(char));

    // P0 computes everyone's n_local and uses it
    // to create a displacement array, for use with MPI_Scatterv.
    if (myrank == 0) {

        sizes = (int *)malloc(numprocs * sizeof(int));
        disps = (int *)malloc((numprocs + 1) * sizeof(int));

        disps[0] = 0;
        for (int i = 0; i < numprocs; i ++) {
            sizes[i] = n / numprocs;
            if (i < n % numprocs) sizes[i] ++;
            disps[i + 1] = disps[i] + sizes[i];
        }
    }

    // Scatter routine. We leave room in the buffer for the overlap.
    if (myrank == 0) init_disp = 0;
    else init_disp = l - 1;

    MPI_Scatterv(text, sizes, disps, MPI_CHAR, &text_local[init_disp], n_local, MPI_CHAR, 0, MPI_COMM_WORLD);

    // Send the overlap. Note that here, the send/recvs are pretty much done sequentially.
    // What that means is, this is probably the worst way to do it. I'll, uh, leave fixing it as an exercise. Yeah.
    if (numprocs > 0) {

        if (myrank != 0) MPI_Recv(text_local,  l - 1,  MPI_CHAR, myrank - 1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

        if (myrank != numprocs - 1) MPI_Send(&text_local[n_local - l], l - 1, MPI_CHAR, myrank + 1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
    }

    // Search
    // etc etc

    MPI_Finalize();
}
